import math 
import random 

def normal_generator(m,d,n):
    
    l=[]
    v=[]

    j=0.001

    for i in range(0,1000): 
        l.append(j)
        j=j+1.0

    for i in range(0,n/2):
        u1=random.choice(l)/1000.0
        u2=random.choice(l)/1000.0
        
        x1=math.sin(2*3.1415*u1*math.sqrt(-2*math.log(u2)))
        x2=math.cos(2*3.1415*u1*math.sqrt(-2*math.log(u2)))

        v.append(d*x1+m)
        v.append(d*x2+m)    

    return v

def calcular_beta(m1,d1,m2,d2):
    
    v=[]
    A=d1*d1-d2*d2
    print A
    B=2*(d2*d2*m1-d1*d1*m2)
    print B
    C=2*d2*d2*d1*d1*math.log(d2/d1)-d2*d2*m1*m1+d1*d1*m2*m2
    print C 
    if A!=0: 
      v.append((-B+math.sqrt(B*B-4*A*C))/2*A)
      v.append((-B-math.sqrt(B*B-4*A*C))/2*A)
    else: 
      v.append(-C/B)

    return v    

def Escriure_arff(class1,class2):

    id=open('numeric.arff','w')
    id.write("@relation numeric.arff\n")
    id.write("@attribute atr1 numeric\n")
    id.write("@attribute class {A,B}\n")
    id.write("@data\n")
    
    for item in class1: id.write(str(item)+",A"+"\n")   
    for item in class2: id.write(str(item)+",B"+"\n")

    id.close()  
    
def SACS(class1):

    class1.sort()
    s=0.0
    k=100000.0
    centroid=k

    for item in class1: s=s+item 

    s=s/len(class1)
    
    for item in class1: 
        if math.fabs(s-item)<k:
           centroid=item
           k=math.fabs(s-item)  

    return centroid

def split(class1,class2):
	
    centroid1=SACS(class1)
    centroid2=SACS(class2)
    
    split1=[]
    split2=[]

    samples=class1+class2
    for item in samples:
        if math.fabs(centroid1-item)<=math.fabs(centroid2-item):split1.append(item)
        else: split2.append(item)
    
    split1.sort()
    split2.sort()
 
    interval1="centroid: "+str(centroid1)+" ["+str(split1[0])+" , "+str(split1[len(split1)-1])+"]\n"       
    interval2="centroid: "+str(centroid2)+" ["+str(split2[0])+" , "+str(split2[len(split2)-1])+"]\n"       

    print "inrtervals del SACS\n"
    print interval1
    print interval2

##########################################  M A I N #######################################################

class1=[]
class2=[]

class1=normal_generator(180,10,1000)
class2=normal_generator(130,8,1000)

Escriure_arff(class1,class2)

split(class1,class2)
